#include <bits/stdc++.h>

using namespace std;
#define int long long

int n, m, mod = 1e9+7;
vector<pair<int, int>> a[210];
int dp[210][110][110];
int x[110], y[110];

void update (int i, int p, int q) {
    if (p == q) {
        return;
    }
    if (p-q == 1) {
        dp[i][p][q] = dp[i-1][p][q] + dp[i-1][p-1][q-1] + dp[i-1][p][q-1];
        return;
    }
    if (q-p == 1) {
        dp[i][p][q] = dp[i-1][p][q] + dp[i-1][p-1][q-1] + dp[i-1][p-1][q];
        return;
    }
    dp[i][p][q] = dp[i-1][p][q] + dp[i-1][p-1][q-1] + dp[i-1][p-1][q] + dp[i-1][p][q-1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int k;
    cin >> n >> m >> k;
    for (int i = 0 ; i < k; i++) {
        cin >> x[i] >> y[i];
        a[x[i] + y[i]].emplace_back(x[i], y[i]);
    }
    dp[3][1][2] = 1;
    dp[3][2][1] = 1;
    for (int i = 4; i <= n+m; i++) {
        if (a[i].empty()) {
            for (int p = 1; p <= n; p++) {
                for (int q = 1; q <= n; q++) {
                    update(i, p, q);
                }
            }
        } else if (a[i].size() == 1) {
            int p = a[i][0].first, q;
            for (q = 1; q <= n; q++) {
                update(i, p, q);
            }
            q = a[i][0].first;
            for (p = 1; p <= n; p++) {
                update(i, p, q);
            }
        } else if (a[i].size() == 2) {
            int p = a[i][0].first, q = a[i][1].first;
            update(i, p, q);
            update(i, q, p);
        }

    }
    cout << dp[m+n-1][n][n-1] + dp[m+n-1][n-1][n];
    return 0;
}